/******************************************************************************************************************************************************
 * Name         :   BRPreviewCtlr.cls
 * Description  :   Controller for Preview component. 
 * Author       :   Pooja Dhiman
 * Created On   :   08/14/2017
******************************************************************************************************************************************************/
public without Sharing class CPGPreviewCtlr {
    
    @AuraEnabled
    public static List<Data_Object__c> getDataSetInformation(String dataSourceId) {
        /*Integer countNumberOfField = database.countQuery('select count() from File_Columns__c where File_MetaData__c =: dataSourceId');
        system.debug('countNumberOfField-->'+countNumberOfField);
        List<File_Columns__c> fileColumnInstance = [Select Id,Name,File_MetaData__c,Data_Type__c from File_Columns__c where File_MetaData__c =: dataSourceId];
        return fileColumnInstance;*/
        List<Data_Object__c> dataObjectInstance = [Select Id,name,total_record__c,Total_field_count__c,LastModifiedBy.Name,CreatedBy.Name from Data_Object__c];
        return dataObjectInstance;
    }

    @AuraEnabled
    public static List<String> getLocaleDateFormats() {
        return new List<String>{SalesIQUtility.getUserDateFormat(), SalesIQUtility.getUserDateTimeFormat()};
    }

    @AuraEnabled
    public static List<Map<String, List<String>>> convertedData(String dateData, String numberData){
        System.debug('convertedData ');
        Map<String, List<String>> mapColumnDateList = new Map<String, List<String>>();
        if(dateData != null && dateData != ''){
            System.debug('inside dateData');
            mapColumnDateList = (Map<String,List<String>>) JSON.deserialize(dateData, Map<String,List<String>>.Class);
            System.debug('mapColumnDateList ' + mapColumnDateList);

            for(String str : mapColumnDateList.keySet()){
                List<String> formatteddates = new List<String>();
                for(String datesVal : mapColumnDateList.get(str)){
                    
                    if(datesVal == null || datesVal == '' || datesVal == 'NaT'){
                        formatteddates.add(datesVal);
                        continue;
                    }
                    System.debug('datesVal ' + datesVal );
                    String originalDate = datesVal.split(' ')[0];
                    String day = originalDate.split('/')[0];
                    String month = originalDate.split('/')[1];
                    String year = originalDate.split('/')[2];

                    String originalTime = datesVal.split(' ')[1];
                    String resultantDate = year + '-' + month + '-' + day + ' ' + originalTime;
                    System.debug('resultantDate ' + resultantDate);
                    Datetime st = Datetime.valueOf(resultantDate); 
                    system.debug('ST'+st);
                    system.debug('formatteddates'+st.format());
                    formatteddates.add(st.format());
                }
                mapColumnDateList.put(str, formatteddates);
            }
        }

        Map<String, List<String>> mapColumnNumberList = new Map<String, List<String>>();
        if(numberData != null && numberData != ''){
            System.debug('inside numberData');
            mapColumnNumberList = (Map<String,List<String>>) JSON.deserialize(numberData, Map<String,List<String>>.Class);
            System.debug('mapColumnNumberList ' + mapColumnNumberList);

            for(String str : mapColumnNumberList.keySet()){
                List<String> formattedNumbers = new List<String>();
                for(String numberVal : mapColumnNumberList.get(str)){
                    if(numberVal == null || numberVal == ''){
                        formattedNumbers.add(numberVal);
                        continue;
                    }

                    Decimal val = decimal.ValueOf(numberVal);
                    Decimal rounded = val.setScale(5);
                    system.debug('VALUE'+ rounded);
                    system.debug('FORMATED VALUE'+ rounded.format());
                    formattedNumbers.add(rounded.format());
                }
                mapColumnNumberList.put(str, formattedNumbers);
            }
        }

        return new List<Map<String, List<String>>>{mapColumnDateList,mapColumnNumberList};
    }

    @AuraEnabled
    public static List<String> getformatedDates(List<String> datesVal) {
         system.debug('datesVal'+datesVal);
         List<String> formatteddates = new List<String>();
         for(Integer ctr=0; ctr<datesVal.size();ctr++){
           system.debug('datesVal inside loop'+datesVal[ctr]);
           //formatteddates.add(datesVal[ctr].format());
           //Datetime st = Datetime.parse(datesVal[ctr]);
           //String dates = '2024-06-01 10:36:04';
           //Date st = Date.valueOf(dates);

          // String testDateString = '06-01-2024 10:36'.replace('-','/');
           //DateTime st = DateTime.parse(testDateString);
           //String convertedDate = st.formatGmt('yyyy-MM-dd\'T\'HH:mm:ss\'Z\'');
           //System.debug('xxx'+convertedDate); 
           //String strDate2 = '2017-07-21 00:00:00';
            //Datetime st = Datetime.valueOf(strDate2); 
           String originalDate = datesVal[ctr].split(' ')[0];
           String day = originalDate.split('/')[0];
           String month = originalDate.split('/')[1];
           String year = originalDate.split('/')[2];

           String originalTime = datesVal[ctr].split(' ')[1];
           String resultantDate = year + '-' + month + '-' + day + ' ' + originalTime;
           System.debug('resultantDate ' + resultantDate);
           Datetime st = Datetime.valueOf(resultantDate); 
           system.debug('ST'+st);
           system.debug('formatteddates'+st.format());
           formatteddates.add(st.format());

         }
     return formatteddates;
    }

    @AuraEnabled
    public static Map<String, List<String>> getFormatedNumbersMap(String numberString){
        Map<String, List<String>> mapColumnNumberList = new Map<String, List<String>>();
        mapColumnNumberList = (Map<String,List<String>>) JSON.deserialize(numberString, Map<String,List<String>>.Class);
        System.debug('mapColumnNumberList ' + mapColumnNumberList);

        for(String str : mapColumnNumberList.keySet()){
            List<String> formattedNumbers = new List<String>();
            for(String numberVal : mapColumnNumberList.get(str)){
                
                Decimal val = decimal.ValueOf(numberVal);
                Decimal rounded = val.setScale(5);
                system.debug('VALUE'+ rounded);
                system.debug('FORMATED VALUE'+ rounded.format());
                formattedNumbers.add(rounded.format());
            }
            mapColumnNumberList.put(str, formattedNumbers);
        }
        return mapColumnNumberList;
    }

     @AuraEnabled
    public static List<String> getformatedNumbers(List<String> numberVal) {
         system.debug('numberVal'+numberVal);
         system.debug('numberVal'+numberVal[0]);

         List<String> formattedNumbers = new List<String>();
         for(Integer ctr=0; ctr<numberVal.size();ctr++){
           //system.debug('numberVal inside loop'+numberVal[ctr]);
           //system.debug('formatted number' + Integer.ValueOf(numberVal[ctr]).format());
           //String randomval = '23.554455546';
           //Decimal valCheck = decimal.ValueOf(randomval);
           Decimal val = decimal.ValueOf(numberVal[ctr]);

           Decimal rounded = val.setScale(5);
           system.debug('VALUE'+ rounded);
           system.debug('FORMATED VALUE'+ rounded.format());
           formattedNumbers.add(rounded.format());
          }
        // String num = numberVal.format();
         system.debug(formattedNumbers);
         return formattedNumbers;
     }

    @AuraEnabled
    public static List<BRColumnInfoWrapper> GetSourceAndDerivedFields(string ScenarioRuleInstanceId){
       List<BRColumnInfoWrapper> lstColumnInfoWrapper = new List<BRColumnInfoWrapper>();

       Set<String> columnNameSet = new Set<String>();
       try{
             List<Scenario_Rule_Instance_Details__c> lstScenarioRuleInstId = [SELECT Id,Status__c FROM Scenario_Rule_Instance_Details__c WHERE Id =: ScenarioRuleInstanceId];
             List<Data_Set_Rule_Map__c> lstDataSetRuleMap=new List<Data_Set_Rule_Map__c>(); 
             List<Data_Set_Column_Detail__c> lstDataColumnDetail=new List<Data_Set_Column_Detail__c>();   
             if(lstScenarioRuleInstId[0].Status__c == 'Success'){
                lstDataSetRuleMap=[select dataset_id__c from Data_Set_Rule_Map__c 
                                where scenario_rule_instance_id__r.Id= :ScenarioRuleInstanceId and ds_type__c='O' and dataset_id__c !=null];
             } else{
                lstDataSetRuleMap=[select dataset_id__c from Data_Set_Rule_Map__c 
                                where scenario_rule_instance_id__r.Id= :ScenarioRuleInstanceId and ds_type__c='I' and dataset_id__c !=null];
             }    
             system.debug('lstDataSetRuleMap:::'+lstDataSetRuleMap);
                if(lstDataSetRuleMap!=null && lstDataSetRuleMap.size()>0){
                    for(integer ctr=0;ctr<lstDataSetRuleMap.size();ctr++){
                       lstDataColumnDetail= [select ds_col_name__c,variable_type__c,value_type__c,datatype__c,tb_col_nm__c,Data_Set_Field_Desc__c from Data_Set_Column_Detail__c 
                                            where dataset_id__r.Id= :lstDataSetRuleMap[0].dataset_id__c AND Is_Visible__c = true ];
                       if(lstDataColumnDetail!=null && lstDataColumnDetail.size()>0){
                           for(Data_Set_Column_Detail__c obj : lstDataColumnDetail){
                              //  if(!columnNameSet.contains(obj.ds_col_name__c)){
                             //       columnNameSet.add(obj.ds_col_name__c);
                                    lstColumnInfoWrapper.add(new BRColumnInfoWrapper(obj.ds_col_name__c,obj.datatype__c,obj.Data_Set_Field_Desc__c,obj.value_type__c,obj.variable_type__c,obj.tb_col_nm__c));
                             //   }
                           }
                         
                       }
                    }
                }
                System.debug('--lstColumnInfoWrapper ' + lstColumnInfoWrapper);
          } 
        catch(Exception ex){
             CPGUtility.InsertErrorLog(ex.getMessage(),ex.getStackTraceString());
        }
        return lstColumnInfoWrapper;
        
    }
    
    @AuraEnabled
    public static List<String> getInstanceNameAndURL(){
        List<String> lstInstanceNameAndURL = new List<String>();
        string cpgInstanceName =  CPGUtility.getBRMSConfigValues('BRDatabaseName');
        lstInstanceNameAndURL.add(cpgInstanceName);
        string cpgInstanceURL =  CPGUtility.getBRMSConfigValues('BRUrl');
        lstInstanceNameAndURL.add(cpgInstanceURL);
        string cpgReportsURL =  CPGUtility.getBRMSConfigValues('BRReportsUrl');
        lstInstanceNameAndURL.add(cpgReportsURL);
        string cpgContextName =  CPGUtility.getBRMSConfigValues('BRContextName');
        lstInstanceNameAndURL.add(cpgContextName);
        string cpgExportAllURL =  CPGUtility.getBRMSConfigValues('BRExportAll');
        lstInstanceNameAndURL.add(cpgExportAllURL);
        return lstInstanceNameAndURL;
    }

    @AuraEnabled
    public static List<BRColumnInfoWrapper> getColumnInformation(String dataSourceId) {
        List<BRColumnInfoWrapper> lstColumnInfoWrapper = new List<BRColumnInfoWrapper>();
        List<Data_Set_Column_Detail__c> columnList = [SELECT datatype__c,Data_Set_Field_Desc__c,ds_col_name__c,Id,tb_col_nm__c,value_type__c,variable_type__c FROM Data_Set_Column_Detail__c WHERE dataset_id__c =:dataSourceId AND dataset_id__c !=null];
        for(Data_Set_Column_Detail__c obj: columnList){
            lstColumnInfoWrapper.add(new BRColumnInfoWrapper(obj.ds_col_name__c,obj.datatype__c,obj.Data_Set_Field_Desc__c,obj.value_type__c,obj.variable_type__c,obj.tb_col_nm__c));
        }
        return lstColumnInfoWrapper;
    }

    /*@AuraEnabled
    public static Map < String,Object > getCalloutResponseContents(String url) 
    {
        Http h = new Http();
 
        // Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
        HttpRequest req = new HttpRequest();
        req.setEndpoint(url);
        req.setMethod('GET');
        req.setHeader('Content-Type', 'application/json');
        req.setHeader('Accept','application/json');
        // Send the request, and return a response
        HttpResponse res = h.send(req);
        System.debug('response:--> ' + res.getBody());
 
        // Deserialize the JSON string into collections of primitive data types.
        Map < String,Object > resultsMap = (Map < String, Object > ) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);
 
        return resultsMap;
    }*/

    @AuraEnabled
    public static Map < String,Object > getCalloutResponse(String url, String tableName, String scenarioRuleInstanceId) 
    {
        system.debug('scenarioRuleInstanceId:: '+scenarioRuleInstanceId);
        system.debug('tableName:: '+tableName);
        system.debug('url:: '+url);
        String whereClause = '';

        //SSL CHANGES
        Map<String,String> urlParams = new Map<String,String>();
        urlParams.put('serviceUrl',url);

        List<Data_Set_Rule_Map__c> dataSetRuleMapObj = [SELECT scenario_rule_instance_id__r.Scenario_Id__c, base_data_set_Id__c,Business_Rule_Template_Details__c,dataset_id__r.Base_Data_Set__c,DS_Rule_Map_Id__c,ds_type__c,table_name__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: ScenarioRuleInstanceId AND ds_type__c = 'I' Limit 1]; 

        system.debug('dataSetRuleMapObj::: '+dataSetRuleMapObj);
        if(dataSetRuleMapObj.size() > 0)
        {
            List<Scenario_Data_Object_Map__c> scDataMapObj = [Select id, Scenario__c,Filter_Expression_Destination__c from Scenario_Data_Object_Map__c where Scenario__c =: dataSetRuleMapObj[0].scenario_rule_instance_id__r.Scenario_Id__c and Data_Set__c =: dataSetRuleMapObj[0].dataset_id__r.Base_Data_Set__c Limit 1];
            system.debug('scDataMapObj::: '+scDataMapObj);
            if(scDataMapObj.size() > 0 && scDataMapObj[0].Filter_Expression_Destination__c != null)
                whereClause = scDataMapObj[0].Filter_Expression_Destination__c;
            system.debug('whereClause::: '+whereClause);
        }

        

        list<ETL_Config__c> lstETLInfo = getETLConfigByName(CPGConstants.talend_Instance);

        String pg_username,pg_password,pg_host,dbName;
        if(lstETLInfo != null && lstETLInfo.size() > 0)
        {
            pg_username = lstETLInfo[0].BR_PG_UserName__c;
            pg_password = lstETLInfo[0].BR_PG_Password__c;
            pg_host = lstETLInfo[0].BR_PG_Host__c;
            dbName = lstETLInfo[0].BR_PG_Database__c;
        }
        String func_Name = 'CGPData';
        //SSL CHANGES
        //url = url+'?pg_username='+pg_username;
        //url = url+'&pg_password='+pg_password;
        //url = url+'&pg_host='+pg_host;
        //url = url+'&db_name='+dbName;
        //url = url+'&functionName='+func_Name;
        //url = url+'&table='+tableName;
        //url = url+'&whereClause='+ EncodingUtil.urlEncode(whereClause, 'UTF-8'); 
        //system.debug('url::::'+url);
        urlParams.put('pg_username',pg_username);
        urlParams.put('pg_password',pg_password);
        urlParams.put('pg_host',pg_host);
        urlParams.put('db_name',dbName);
        urlParams.put('functionName',func_Name);
        urlParams.put('table',tableName);
        urlParams.put('whereClause',EncodingUtil.urlEncode(whereClause, 'UTF-8'));
        system.debug('urlParams::::'+urlParams);



        //SSL CHANGES
        HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);
      

        //Http h = new Http();
        //HttpRequest req = new HttpRequest();
        //req.setEndpoint(url);
        //req.setMethod('GET');
        //req.setHeader('Content-Type', 'application/json');
        //req.setHeader('Accept','application/json');
        //HttpResponse res = h.send(req);
        System.debug('response:--> ' + res.getBody());
 
        // Deserialize the JSON string into collections of primitive data types.
        Map < String,Object > resultsMap = (Map <String, Object> ) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);

        List<Data_Set_Rule_Map__c> inputDatasetIdList = [SELECT dataset_id__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: scenarioRuleInstanceId and ds_type__c = 'I'];
        String datasetId = inputDatasetIdList[0].dataset_id__c;

        List<Data_Set_Column_Detail__c> visibleColumnNameList = [SELECT tb_col_nm__c FROM Data_Set_Column_Detail__c where dataset_id__c =: datasetId and Is_Visible__c = true];

        System.debug('visibleColumnNameList size ::: '+visibleColumnNameList.size());
        Set<String> visibleTbColNames = new Set<String>();
        for(Data_Set_Column_Detail__c dsColums : visibleColumnNameList) {
            visibleTbColNames.add(dsColums.tb_col_nm__c);
        }

        List<Map<String, String>> finalData = new List<Map<String, String>>();
        List<String> finalColHeader = new List<String>();

        List<Object> columnHeaders = (List<Object>) resultsMap.get('columns');
        List<Object> dataList = (List<Object>)resultsMap.get('data');

        if(!dataList.isEmpty()) {

            for(Object colHeader : columnHeaders) {
                if(visibleTbColNames.contains(String.valueOf(colHeader)))
                    finalColHeader.add(String.valueOf(colHeader));
            }

            for(Object rowDataObj : dataList) {
                List<Object> rowData = (List<Object>) rowDataObj ;
                Map<String, String> finalRowData = new Map<String, String>();
                
                for(integer index=0; index < rowData.size(); index++) {
                    if(visibleTbColNames.contains(String.valueOf(columnHeaders[index]))) {
                        if(String.valueOf(rowData[index]) == '')
                            finalRowData.put(String.valueOf(columnHeaders[index]), null);
                        else
                            finalRowData.put(String.valueOf(columnHeaders[index]), String.valueOf(rowData[index]));
                    }
                }
                finalData.add(finalRowData);
            }


            resultsMap.put('data', finalData);
            resultsMap.put('columns', finalColHeader);

            system.debug('resultsMap after changing-->' + resultsMap);
        }
        
        return resultsMap;
    }

    @AuraEnabled
    public static BRPreviewWrapper getDataForUnderLyingData(){
        List<Data_Object__c> dataObjectInstance = [Select Id,Name,dataset_id__c,data_name__c,total_record__c,Total_field_count__c,LastModifiedBy.Name,CreatedBy.Name from Data_Object__c where dataset_id__c!=null];
        system.debug('dataObjectInstance::'+dataObjectInstance);
        Data_Set__c dataSetObj = [Select Id,Name from Data_Set__c where Id =: dataObjectInstance[0].dataset_id__c LIMIT 1];
        return (new BRPreviewWrapper(dataSetObj.Name,dataObjectInstance[0].data_name__c,dataObjectInstance[0].LastModifiedBy.Name,dataObjectInstance[0].CreatedBy.Name,dataObjectInstance[0].total_record__c,dataObjectInstance[0].Total_field_count__c));
    }

    @AuraEnabled
    public static List<Scenario_Rule_Instance_Details__c> getScenarioID(String ScenarioRuleInstanceId){
     
       List<Scenario_Rule_Instance_Details__c> sceID = [SELECT Id, Scenario_Id__c,Scenario_Id__r.Name FROM Scenario_Rule_Instance_Details__c where id=:ScenarioRuleInstanceId];
       return sceID;
    }
    
    @AuraEnabled
    public static String getTableName(string ScenarioRuleInstanceId){
       String tableName;
       List<Scenario_Rule_Instance_Details__c> lstScenarioRuleInstId = [SELECT Id,Status__c FROM Scenario_Rule_Instance_Details__c WHERE  Id =: ScenarioRuleInstanceId];
       system.debug(lstScenarioRuleInstId);
       Data_Set_Rule_Map__c dataSetRuleMapObj;
       //Scenario_Rule_Instance_Details__c scenarioRuleInstanceObj = [SELECT Id,BusinessRuleTemplateId__c,Status__c FROM Scenario_Rule_Instance_Details__c Limit 1];
       if(lstScenarioRuleInstId[0].Status__c == 'Success'){
        dataSetRuleMapObj = [SELECT base_data_set_Id__c,Business_Rule_Template_Details__c,dataset_id__c,DS_Rule_Map_Id__c,ds_type__c,table_name__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: ScenarioRuleInstanceId AND ds_type__c = 'O' Limit 1];
       }else{
        dataSetRuleMapObj = [SELECT base_data_set_Id__c,Business_Rule_Template_Details__c,dataset_id__c,DS_Rule_Map_Id__c,ds_type__c,table_name__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: ScenarioRuleInstanceId AND ds_type__c = 'I' Limit 1];
       }
       
       tableName = dataSetRuleMapObj.table_name__c + ','+ dataSetRuleMapObj.Table_Display_Name__c;
       system.debug('tableName:::'+tableName);
       return tableName;
    }

     @AuraEnabled
    public static String getFileType(string ScenarioRuleInstanceId){
       String fileType;
       List<Scenario_Rule_Instance_Details__c> lstScenarioRuleInstId = [SELECT Id,Status__c FROM Scenario_Rule_Instance_Details__c WHERE  Id =: ScenarioRuleInstanceId];
       system.debug(lstScenarioRuleInstId);
       Data_Set_Rule_Map__c dataSetRuleMapObj;
       //Scenario_Rule_Instance_Details__c scenarioRuleInstanceObj = [SELECT Id,BusinessRuleTemplateId__c,Status__c FROM Scenario_Rule_Instance_Details__c Limit 1];
       if(lstScenarioRuleInstId[0].Status__c == 'Success'){
        dataSetRuleMapObj = [SELECT base_data_set_Id__c,File_Type__c,Business_Rule_Template_Details__c,dataset_id__c,DS_Rule_Map_Id__c,ds_type__c,table_name__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: ScenarioRuleInstanceId AND ds_type__c = 'O' Limit 1];
       }else{
        dataSetRuleMapObj = [SELECT base_data_set_Id__c,File_Type__c,Business_Rule_Template_Details__c,dataset_id__c,DS_Rule_Map_Id__c,ds_type__c,table_name__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: ScenarioRuleInstanceId AND ds_type__c = 'I' Limit 1];
       }
       
       fileType = dataSetRuleMapObj.File_Type__c;
       system.debug('fileType:::'+fileType);
       return fileType;
    }

    @AuraEnabled
    public static String getComponentTypeMasterName(string ScenarioRuleInstanceId){
        string componentName;
        List<Scenario_Rule_Instance_Details__c> lstScenarioRuleInstance = [SELECT Id,ComponentTypeLabel__c,Component_Display_Order__c,Input_Table__c FROM Scenario_Rule_Instance_Details__c where Id=:ScenarioRuleInstanceId];
        componentName = lstScenarioRuleInstance[0].ComponentTypeLabel__c;
        return componentName;
    }

    @AuraEnabled
    public static string getScenarioStatus(String scenarioRuleInstanceId) {
        //string status;
        /*List<Scenario_Rule_Instance_Details__c> lstInstance=[SELECT Scenario_Id__c FROM Scenario_Rule_Instance_Details__c
                                                            where Id= :scenarioRuleInstanceId];
        if(lstInstance!=null && lstInstance.size()>0){
            List<Scenario__c> lstScenario = new List<Scenario__c>();
            lstScenario=[select Id,Request_Process_Stage__c from Scenario__c where Id= :lstInstance[0].Scenario_Id__c];
            if(lstScenario!=null && lstScenario.size()>0){
                status=lstScenario[0].Request_Process_Stage__c;
            } 
        }*/
        
        List<Scenario_Rule_Instance_Details__c> lstInstance=[SELECT Scenario_Id__c, Status__c FROM Scenario_Rule_Instance_Details__c
                                                            where Id= :scenarioRuleInstanceId];
       
        return lstInstance[0].Status__c;
    }


    @AuraEnabled
    public static String getexportAlldetails(string url,string tableName){
       /* List<String> lstBucketDetails = new List<String>();
        string cpgBucketName =  CPGUtility.getBRMSConfigValues('BRBucketUrl');
        lstBucketDetails.add(cpgBucketName);
        string cpgFolderName =  CPGUtility.getBRMSConfigValues('BRFolderName');
        lstBucketDetails.add(cpgFolderName);
        return lstBucketDetails;*/
        system.debug('url'+url);
        system.debug('tablename'+tableName);
         list<ETL_Config__c> lstETLInfo = getETLConfigByName(CPGConstants.talend_Instance);

        String pg_username,pg_password,pg_host,dbName;
        if(lstETLInfo != null && lstETLInfo.size() > 0)
        {
            pg_username = lstETLInfo[0].BR_PG_UserName__c;
            pg_password = lstETLInfo[0].BR_PG_Password__c;
            //pg_host = lstETLInfo[0].BR_PG_Host__c;
            dbName = lstETLInfo[0].BR_PG_Database__c;
        }

        	

        //String func_Name = 'ExportAll';
        //url = url+'/'+func_Name;
        url = url+'?table_name='+tableName;
        url = url+'&dbname='+dbName;
        url = url+'&pg_username='+pg_username;
        url = url+'&pg_password='+pg_password;
        url = url+'&timestamp='+Datetime.now().getTime();
         
        system.debug('url::::'+url);
        
        /*Http h = new Http();
        HttpRequest req = new HttpRequest();
        req.setEndpoint(url);
        req.setMethod('GET');
        req.setHeader('Content-Type', 'application/json');
        req.setHeader('Accept','application/json');
        HttpResponse res = h.send(req);
        System.debug('response:--> ' + res.getBody());
        //String resultsMap = res.getBody();
        // Deserialize the JSON string into collections of primitive data types.
        //Map < String,Object > resultsMap = (Map <String, Object> ) JSON.deserializeUntyped(res.getBody());
        Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);*/
        String message = url;

         
        return message;
    }
    
     /**
     * calling Aggregate Functions custom metatdata types for the aggregation functions dropdown
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2017-09-29  
    */
    
      @AuraEnabled
      public static  CPG_Aggregate_Functions__mdt[] getAggregateFunctionsList(){ 
        List<CPG_Aggregate_Functions__mdt> aggFunctions = [Select Id,Field_Type__c,	Functions__c from CPG_Aggregate_Functions__mdt ];
        system.debug('typesList====>'+aggFunctions);
          return  aggFunctions;
      } 
    /**
     * calling webservices for reports output
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-01-09  
    */
     @AuraEnabled
    public static object webSeriveResponseMethod(String url) {
 
        // Instantiate a new http object
        Http h = new Http();
 
        // Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
        HttpRequest req = new HttpRequest();
        req.setEndpoint(url);
        req.setMethod('GET');
        req.setTimeout(120000);
      //  req.setHeader('Content-Type', 'application/json');
       // req.setHeader('Accept','application/json');
        // Send the request, and return a response
        if(!Test.isRunningTest()){
	        HttpResponse res = h.send(req);
	        System.debug('response:--> ' + res.getBody());
	 
	        // Deserialize the JSON string into collections of primitive data types.
	       //Map<String,Object> finalResult = new Map<String,Object>();
	        Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
	        system.debug('resultsMap-->' + res.getBody());
	        return resultsMap;
           /* Map<String,Object> finalResult = new Map<String,Object>();
	        Map < String,Object > resultsMap = (Map < String, Object > ) JSON.deserializeUntyped(res.getBody());
	        system.debug('resultsMap-->' + resultsMap);
	        return resultsMap;*/
        }
        else{
        	return null;
        }
    }
    
     /**
     * calling webservices for reports output
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-01-09  
    */
     @AuraEnabled
    public static Map< String, Object > webSeriveResponseMethodChart(String url,String query) {
 
        // Instantiate a new http object
        Http h = new Http();
       // Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
        HttpRequest req = new HttpRequest();
        system.debug('query value'+query);
         if(query =='zero'){
          req.setEndpoint(url);
        }else{
         // String q = query.replaceAll('\'', '\'\'');
        //String finalURL = url + q;
          string newtest = query.replaceAll('\\s+','%20');  
           req.setEndpoint(url + newtest); 
        }

        
       
        req.setMethod('GET');
        req.setTimeout(120000);
      //  req.setHeader('Content-Type', 'application/json');
       // req.setHeader('Accept','application/json');
        // Send the request, and return a response
        if(!Test.isRunningTest()){
	        HttpResponse res = h.send(req);
	        System.debug('response:--> ' + res.getBody());
	 
	        // Deserialize the JSON string into collections of primitive data types.
	       //Map<String,Object> finalResult = new Map<String,Object>();
	       // Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
	        //system.debug('resultsMap-->' + res.getBody());
	        //return res.getBody();
            Map<String,Object> finalResult = new Map<String,Object>();
	        Map < String,Object > resultsMap = (Map < String, Object > ) JSON.deserializeUntyped(res.getBody());
	        system.debug('resultsMap-->' + resultsMap);
	        return resultsMap;
        }
        else{
        	return null;
        }
    }
    
       /**
     * calling webservices for reports output for QueryBuilder
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-01-09  
    */
     @AuraEnabled
    public static object webSeriveResponseMethodQueryBuilder(String url, String query) {
 
        // Instantiate a new http object
        Http h = new Http();
 
        //String q = query.replaceAll('\'', '\'\'');
        //String finalURL = url + q;
        system.debug('query in controller'+ query);
        string newtest = query.replaceAll('\\s+','%20');
       // q.replaceAll(' ', '%20');
        //system.debug("value of q'+q);
        // Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
        HttpRequest req = new HttpRequest();
        req.setEndpoint(url + newtest);
        req.setMethod('GET');
        req.setTimeout(120000);
      //  req.setHeader('Content-Type', 'application/json');
       // req.setHeader('Accept','application/json');
        // Send the request, and return a response
        if(!Test.isRunningTest()){
	        HttpResponse res = h.send(req);
	        System.debug('response:--> ' + res.getStatus());
            System.debug('response:--> ' + res.getbody());
	 
	        // Deserialize the JSON string into collections of primitive data types.
	        Map<String,Object> finalResult = new Map<String,Object>();
	        Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
	        system.debug('resultsMap-->' + resultsMap);
	        return resultsMap;
            /* Map<String,Object> finalResult = new Map<String,Object>();
	        Map < String,Object > resultsMap = (Map < String, Object > ) JSON.deserializeUntyped(res.getBody());
	        system.debug('resultsMap-->' + resultsMap);
	        return resultsMap;*/
        }
        else{
        	return null;
        }
    }
    
    /**
     * fetching control chart details through webservice
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-06-19  
    */

    @AuraEnabled
    public static object getCalloutResponseforControlChart(String url, String tableName,String fieldName,String function, String whereClause) 
    {
        
        system.debug('tableName:: '+tableName);
        system.debug('url:: '+url);
        //SSL CHANGES
        Map<String,String> urlParams = new Map<String,String>();
        urlParams.put('serviceUrl',url);
 

        list<ETL_Config__c> lstETLInfo = getETLConfigByName(CPGConstants.talend_Instance);

        String pg_username,pg_password,pg_host,dbName;
        if(lstETLInfo != null && lstETLInfo.size() > 0)
        {
            pg_username = lstETLInfo[0].BR_PG_UserName__c;
            pg_password = lstETLInfo[0].BR_PG_Password__c;
            pg_host = lstETLInfo[0].BR_PG_Host__c;
            dbName = lstETLInfo[0].BR_PG_Database__c;
        }

        whereClause = whereClause.replaceAll('\'','%27');
        whereClause = whereClause.replaceAll('&','%26');

        String func_Name = 'ReportPreview';
        //SSL CHANGES
        //url = url+'?pg_username='+pg_username;
        //url = url+'&pg_password='+pg_password;
        //url = url+'&pg_host='+pg_host;
        //url = url+'&db_name='+dbName;
        //url = url+'&functionName='+func_Name;
        //url = url+'&tableName='+tableName;
        //url = url+'&fieldName='+fieldName;
        //url = url+'&function='+function;
        //url = url+'&condition='+whereClause.replaceAll('\\s+','%20');
        //system.debug('url::::'+url);
        urlParams.put('pg_username',pg_username);
        urlParams.put('pg_password',pg_password);
        urlParams.put('pg_host',pg_host);
        urlParams.put('db_name',dbName);
        urlParams.put('functionName',func_Name);
        urlParams.put('tableName',tableName);
        urlParams.put('fieldName',fieldName);
        urlParams.put('function',function);
        urlParams.put('condition', whereClause.replaceAll('\\s+','%20') );
        system.debug('urlParams::::'+urlParams);


        //SSL CHANGES
        //Http h = new Http();
        //HttpRequest req = new HttpRequest();
        //req.setEndpoint(url);
        //req.setMethod('GET');
        //req.setHeader('Content-Type', 'application/json');
        //req.setHeader('Accept','application/json');
        // HttpResponse res = h.send(req);

        HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);
        System.debug('response:--> ' + res.getBody());
        //String resultsMap = res.getBody();
        // Deserialize the JSON string into collections of primitive data types.
        //Map < String,Object > resultsMap = (Map <String, Object> ) JSON.deserializeUntyped(res.getBody());
        Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);

         
        return resultsMap;
    }

    /**
     * fetching Bar chart details through webservice
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-06-19  
    */

    @AuraEnabled
    public static Map< String, Object > getCalloutResponseforBarChart(Map<String,String> urlParams, String whereClause) {

     // system.debug('tableName:: '+tableName);
        system.debug('urlParams:: '+urlParams);
        
 

        list<ETL_Config__c> lstETLInfo = getETLConfigByName(CPGConstants.talend_Instance);

        String pg_username,pg_password,pg_host,dbName;
        if(lstETLInfo != null && lstETLInfo.size() > 0)
        {
            pg_username = lstETLInfo[0].BR_PG_UserName__c;
            pg_password = lstETLInfo[0].BR_PG_Password__c;
            pg_host = lstETLInfo[0].BR_PG_Host__c;
            dbName = lstETLInfo[0].BR_PG_Database__c;
        }
        String func_Name = 'ReportPreviewSummary';
        //url = url+'?pg_username='+pg_username;
        //url = url+'&pg_password='+pg_password;
        //url = url+'&pg_host='+pg_host;
        //url = url+'&db_name='+dbName;
        //url = url+'&functionName='+func_Name;
        //url = url+ urlPara;
        //url = url+'&condition='+whereClause.replaceAll('\\s+','%20'); 
        //system.debug('url::::'+url);
        urlParams.put('pg_username',pg_username);
        urlParams.put('pg_password',pg_password);
        urlParams.put('pg_host',pg_host);
        urlParams.put('db_name',dbName);
        urlParams.put('functionName',func_Name);
        urlParams.put('condition',whereClause.replaceAll('\\s+','%20'));



        //Http h = new Http();
        //HttpRequest req = new HttpRequest();
        //req.setEndpoint(url);
        //req.setMethod('GET');
        //req.setHeader('Content-Type', 'application/json');
        //req.setHeader('Accept','application/json');
        //HttpResponse res = h.send(req);

        //SSL CHANGES
        HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);
      
        System.debug('response:--> ' + res.getBody().substring(2,res.getBody().length() - 2));
        //String resultsMap = res.getBody();
        // Deserialize the JSON string into collections of primitive data types.
        Map < String,Object > resultsMap = (Map <String, Object> ) JSON.deserializeUntyped(res.getBody().substring(2,res.getBody().length() - 2));
        //Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);

         
        return resultsMap;

    }

    /**
     * fetching Pie chart details through webservice
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-06-19  
    */

    @AuraEnabled
    public static Map< String, Object > getCalloutResponseforPieChart(Map<String,String> urlParams , String whereClause) {

        //system.debug('tableName:: '+tableName);
        //system.debug('url:: '+url);
         
 

        list<ETL_Config__c> lstETLInfo = getETLConfigByName(CPGConstants.talend_Instance);

        String pg_username,pg_password,pg_host,dbName;
        if(lstETLInfo != null && lstETLInfo.size() > 0)
        {
            pg_username = lstETLInfo[0].BR_PG_UserName__c;
            pg_password = lstETLInfo[0].BR_PG_Password__c;
            pg_host = lstETLInfo[0].BR_PG_Host__c;
            dbName = lstETLInfo[0].BR_PG_Database__c;
        }
        String func_Name = 'ReportPreviewPieChart';
        //url = url+'?pg_username='+pg_username;
        //url = url+'&pg_password='+pg_password;
        //url = url+'&pg_host='+pg_host;
        //url = url+'&db_name='+dbName;
        //url = url+'&functionName='+func_Name;
        //url = url+ urlPara;
        //url = url+'&condition='+whereClause.replaceAll('\\s+','%20');
        //system.debug('url::::'+url);

        urlParams.put('pg_username',pg_username);
        urlParams.put('pg_password',pg_password);
        urlParams.put('pg_host',pg_host);
        urlParams.put('db_name',dbName);
        urlParams.put('functionName',func_Name);
        urlParams.put('condition',whereClause.replaceAll('\\s+','%20'));


        //SSL CHANGES
        //Http h = new Http();
        //HttpRequest req = new HttpRequest();
        //req.setEndpoint(url);
        //req.setMethod('GET');
        //req.setHeader('Content-Type', 'application/json');
        //req.setHeader('Accept','application/json');
        //HttpResponse res = h.send(req);
        HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);
      
        System.debug('response without substring:--> '+res.getBody());
        System.debug('response:--> ' + res.getBody().substring(2,res.getBody().length() - 2));
        //String resultsMap = res.getBody();
        // Deserialize the JSON string into collections of primitive data types.
        Map < String,Object > resultsMap = (Map <String, Object> ) JSON.deserializeUntyped(res.getBody().substring(2,res.getBody().length() - 2));
        //Object  resultsMap = (object) JSON.deserializeUntyped(res.getBody());
        system.debug('resultsMap-->' + resultsMap);

         
        return resultsMap;

    }

    /**
     * calling parser for reports output for Query Builder
     *  
     *  @author  Aakash Gupta
     *  @version 1.0
     *  @since   2018-02-13  
    */
    @AuraEnabled
    public static String reportsFilterParser(String query) {
        system.debug('QUERY---->'+query);
        /*String equalQuery = query;
        if(query.contains('not equals')){
            equalQuery = equalQuery.replaceAll('not equals','!=');  
            system.debug('QUERY---->'+ equalQuery);
        } 
        
        if(query.contains('equals')){
            equalQuery = equalQuery.replaceAll('equals','=');  
            system.debug('QUERY---->'+ equalQuery);
        }
        
        if(query.contains('contains')){  	
            equalQuery = equalQuery.replaceAll('contains','like');
            List<String> likeStrings = equalQuery.split('like');
            System.debug('--equalQuery ' + equalQuery);
            System.debug('--likeStrings ' + likeStrings);
            
            for(Integer ind=1; ind < likeStrings.size(); ind=ind+2){
                String intermediateString = likeStrings[ind].trim(); 
                System.debug('--intermediateString ' + intermediateString);
                List<String> intermediateList = intermediateString.split(' ');
                System.debug(intermediateList[0]);
                String strInt = intermediateList[0].replaceAll('\'\'', '');
                equalQuery = equalQuery.replace(intermediateList[0], '\'%' + strInt + '%\''); 
                System.debug(equalQuery);
            }

            System.debug(equalQuery);
        }
        
        if(query.contains('in')){
            
        }  */
        
        return query;
    }

    public static List<ETL_Config__c> getETLConfigByName(string etlConfigName){
        List<ETL_Config__c> etlConfigList;
            etlConfigList = [SELECT BDT_DataSet_Id__c,BR_Data_Object_Id__c,BR_PG_Database__c,BR_PG_Host__c,BR_PG_Password__c,BR_PG_Port__c,BR_PG_Schema__c,BR_PG_UserName__c,BR_Secret_Key__c,CreatedById,CreatedDate,End_Point__c,ESRI_Password__c,ESRI_UserName__c,GI_Dataset_Id__c,Id,Name,S3_Access_Key__c,S3_Bucket__c,S3_Filename__c,S3_Key_Name__c,S3_Security_Token__c,Server_Type__c,SFTP_Folder__c,SFTP_Host__c,SFTP_Password__c,SFTP_Port__c,SFTP_Username__c,SF_Password__c,SF_UserName__c FROM ETL_Config__c where name =:etlConfigName limit 1];
        return etlConfigList;
    }
   
}